package ru.dbotthepony.mc.otm.block;

import net.minecraft.core.BlockPos;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.EntityBlock;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.entity.BlockEntityTicker;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.shapes.BooleanOp;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.phys.shapes.VoxelShape;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityBatteryBank;

import javax.annotation.Nullable;

public class BlockBatteryBank extends BlockMatteryRotatable implements EntityBlock {
	@Nullable
	@Override
	public <T extends BlockEntity> BlockEntityTicker<T> getTicker(Level level, BlockState p_153213_, BlockEntityType<T> type) {
		return level.isClientSide || type != Registry.BlockEntities.BATTERY_BANK ? null : BlockEntityBatteryBank::tick;
	}

	@Nullable
	@Override
	public BlockEntity newBlockEntity(BlockPos blockPos, BlockState blockState) {
		return new BlockEntityBatteryBank(blockPos, blockState);
	}

	@Override
	public boolean faceToPlayer(BlockPlaceContext context) {
		return false;
	}

	public static final VoxelShape SHAPE;

	@Override
	public VoxelShape getShape(BlockState p_60555_, BlockGetter p_60556_, BlockPos p_60557_, CollisionContext p_60558_) {
		return SHAPE;
	}

	static {
		VoxelShape final_shape = Shapes.box(0.125, 0.125, 0.125, 0.875, 0.875, 0.875);

		// вертикальные балки
		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0, 0,
			0.125, 1, 0.125
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0, 0.875,
			0.125, 1, 1
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0.875, 0, 0,
			1, 1, 0.125
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0.875, 0, 0.875,
			1, 1, 1
		), BooleanOp.OR);

		// горизонтальные балки сверху
		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0.875, 0,
			0.125, 1, 1
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0.875, 0,
			1, 1, 0.125
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0.875, 0.875, 0,
			1, 1, 1
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0.875, 0.875,
			1, 1, 1
		), BooleanOp.OR);

		// горизонтальные балки снизу
		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0, 0,
			0.125, 0.125, 1
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0, 0,
			1, 0.125, 0.125
		), BooleanOp.OR);

		final_shape = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0.875, 0, 0,
			1, 0.125, 1
		), BooleanOp.OR);

		SHAPE = Shapes.joinUnoptimized(final_shape, Shapes.box(
			0, 0, 0.875,
			1, 0.125, 1
		), BooleanOp.OR);
	}
}
